local Gnoll = _G.Gnoll
local GL = Gnoll.Locale
local GLW = Gnoll.WoWLocale

local function hideWishList()
	ItemFrameButton:Hide()
	WishFrameButton:Show()
	ItemFrame:Show()
	WishFrame:Hide()
end


local function checkitems()
	local leer = false

	for i=1, 30 do
		if ItemButtons[i]:IsShown() == true then		
			if ItemButtons[i]:GetText() == "Getting ItemInfo" then
				leer = true
			end
		end
	end
	
	if leer == true then
		local kontinent = tonumber(DDME["selectedID"])
		local instanz  = tonumber(DDMI["selectedID"])
		local dif = tonumber(DDMD["selectedValue"]) or 0
		local class = tonumber(DDMC["selectedValue"]) or 0
		local spec = tonumber(DDMS["selectedValue"]) or 0
		local instid = Gnoll.Data.Instanzen[kontinent][instanz]
		local encounter = Gnoll.Data.Bosse[kontinent][instanz][boss]
		LootAbfrage(kontinent,dif,instid,encounter,class,spec,UpdateItems)
	end
end

local function LootAbfrageStart(arg1)
	if arg1 == "first" then boss = 1 else boss = tonumber(DDMB["selectedID"]) end
	local kontinent = tonumber(DDME["selectedID"])
	local instanz  = tonumber(DDMI["selectedID"])
	local dif = tonumber(DDMD["selectedValue"]) or 0
	local class = tonumber(DDMC["selectedValue"]) or 0
	local spec = tonumber(DDMS["selectedValue"]) or 0
	local instid = Gnoll.Data.Instanzen[kontinent][instanz]
	local encounter = Gnoll.Data.Bosse[kontinent][instanz][boss]
	LootAbfrage(kontinent,dif,instid,encounter,class,spec,UpdateItems)
	C_Timer.After(0.5, checkitems)
end

-----------------------------------------------------------------
----------------------------------------------------------------- E
-----------------------------------------------------------------

local function OnClickDDME(self)                --- Kontinent wurde ausgewhlt Instanz Dingens wird erstellt
	ClearItemButtons()
    UIDropDownMenu_SetSelectedID(DDME, self:GetID())
    UIDropDownMenu_SetText(DDMI, GL["Instance"], 0)
    UIDropDownMenu_SetText(DDMB, GL["Boss"], 0)
	hideWishList()
end

local function initializeDDME(self, level)      --- Addons werden aufgelistet
	local info = UIDropDownMenu_CreateInfo()  
	for k,v in pairs(Gnoll.Data.Addons) do
		info = UIDropDownMenu_CreateInfo()
		info.text = v
		info.value = v
		info.func = OnClickDDME
		UIDropDownMenu_AddButton(info, level)
	end
end
UIDropDownMenu_Initialize(DDME, initializeDDME)

-----------------------------------------------------------------
-----------------------------------------------------------------
----------------------------------------------------------------- D

local function OnClickDDMD(self,event,arg1)                --- Difficu
    UIDropDownMenu_SetSelectedID(DDMD, self:GetID())
	DDMD["selectedValue"] = self.value
	ClearItemButtons()
	LootAbfrageStart()
	hideWishList()
end

local function initializeDDMD(self, level)          -- Specs  Wird genereirt  (muss leider hier stehen :-()
    local info = UIDropDownMenu_CreateInfo()  
    local tmpE = DDME["selectedID"]
    local tmpI = DDMI["selectedID"]
	
    for k,v in pairs(Gnoll.Data.Difficulty[tmpE][tmpI]) do
        info = UIDropDownMenu_CreateInfo()
        info.text = GLW["Difficulty"][v]
        info.value = v
        info.func = OnClickDDMD
        UIDropDownMenu_AddButton(info,1)
    end
end

-----------------------------------------------------------------
----------------------------------------------------------------- B
-----------------------------------------------------------------

local function OnClickDDMB(self)                --- Boss  wurde ausgewhlt
	UIDropDownMenu_SetSelectedID(DDMB, self:GetID())
	ClearItemButtons()
	LootAbfrageStart()
	hideWishList()
end
 
local function initializeDDMB(self, level)          -- Bosse werden aufgelistet
    local info = UIDropDownMenu_CreateInfo()  
    local tmpE = DDME["selectedID"]
    local tmpI = DDMI["selectedID"]
    for k,v in pairs(Gnoll.Data.Bosse[tmpE][tmpI]) do
        info = UIDropDownMenu_CreateInfo()
        if type(v) == "number" then
            info.text = EJ_GetEncounterInfo(v)
        else
            info.text = v.."!!!"
        end
        info.value = v
        info.func = OnClickDDMB
        UIDropDownMenu_AddButton(info, level)
    end
end
UIDropDownMenu_Initialize(DDMB, initializeDDMB)

-----------------------------------------------------------------
----------------------------------------------------------------- I
-----------------------------------------------------------------

local function OnClickDDMI(self)                --- Instanz wurde ausgewhlt
    UIDropDownMenu_SetSelectedID(DDMI, self:GetID())
    UIDropDownMenu_SetText(DDMB, GL["Boss"], 0)
	UIDropDownMenu_Initialize(DDMD, initializeDDMD) -->Aufruf Difficulty zu erzeugen
	local tmpE = DDME["selectedID"]
    local tmpI = DDMI["selectedID"]
	local firstdiff = Gnoll.Data.Difficulty[tmpE][tmpI][1]
	DDMD["selectedID"] = firstdiff
	UIDropDownMenu_SetSelectedValue(DDMD, firstdiff, firstdiff)
	UIDropDownMenu_SetText(DDMD, GLW["Difficulty"][firstdiff])
	
	firstboss = Gnoll.Data.Bosse[tmpE][tmpI][1]
	
	
	UIDropDownMenu_SetSelectedID(DDMB, 1)
	UIDropDownMenu_SetText(DDMB, EJ_GetEncounterInfo(firstboss))
	
	ClearItemButtons()
	LootAbfrageStart("first")
	hideWishList()
end

local function initializeDDMI(self, level)          -- Instanzen werden aufgelistet
    local info = UIDropDownMenu_CreateInfo()  
    local tmp = DDME["selectedID"]
    for k,v in pairs(MapIDS[tmp]) do
        info = UIDropDownMenu_CreateInfo()
        if type(v) == "number" then
            info.text = GetMapNameByID(v)
        else
            info.text = v
        end
        info.value = v
        info.func = OnClickDDMI
        UIDropDownMenu_AddButton(info, level)
   end
end
UIDropDownMenu_Initialize(DDMI, initializeDDMI)

----------------------------------------------------------------
----------------------------------------------------------------- C & S
-----------------------------------------------------------------

local function OnClickDDMS(self,event,arg1)                --- Spec ausgewhlt
    UIDropDownMenu_SetSelectedID(DDMS, self:GetID())
	DDMS["selectedValue"] = self.value
	ClearItemButtons()
	LootAbfrageStart()
	hideWishList()
end

local function initializeDDMS(self, level)         -- Specs  Wird genereirt  (muss leider hier stehen :-()
	local class = DDMC["selectedValue"]
    local info = UIDropDownMenu_CreateInfo()
	
	if class == 0 then 
		---keine Specs anzeigen
		UIDropDownMenu_SetText(DDMS, GL["All"], 0)
	else
	
		for k,v in pairs(Gnoll.Data.ClassSpecs[class]) do
			info = UIDropDownMenu_CreateInfo()
			info.text = GLW["Specs"][v]
			info.value = v
			info.func = OnClickDDMS
			UIDropDownMenu_AddButton(info,1)
		end
	end
end

local function OnClickDDMC(self)                --- Class wurde ausgewhlt
    UIDropDownMenu_SetSelectedID(DDMC, self:GetID())
	DDMC["selectedValue"] = self.value
	ClearItemButtons()
	LootAbfrageStart()
	hideWishList()
	UIDropDownMenu_Initialize(DDMS, initializeDDMS)
end

local function initializeDDMC(self, level)          -- Klassen werden aufgelistet
    local info = UIDropDownMenu_CreateInfo()  
	
		info = UIDropDownMenu_CreateInfo()
        info.text = GL["All"]
		info.value = 0
        info.func = OnClickDDMC
        UIDropDownMenu_AddButton(info, level)
	
    for i=2, GetNumClasses() do
        info = UIDropDownMenu_CreateInfo()
        info.text = GetClassInfo(i) 
		info.value = i
        info.func = OnClickDDMC
        UIDropDownMenu_AddButton(info, level)
    end
end
UIDropDownMenu_Initialize(DDMC, initializeDDMC)